Skip to content
Start here

Create a list

client.rules.lists.create(ListCreateParams { account_id, kind, name, description } params, RequestOptionsoptions?): ListCreateResponse { id, created_on, kind, 5 more }
POST/accounts/{account_id}/rules/lists

Creates a new list of the specified kind.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Account Filter Lists Edit
ParametersExpand Collapse
params: ListCreateParams { account_id, kind, name, description }
account_id: string

Path param: The Account ID for this resource.

maxLength32
minLength32
kind: "ip" | "redirect" | "hostname" | "asn"

Body param: The type of the list. Each type supports specific list items (IP addresses, ASNs, hostnames or redirects).

One of the following:
"ip"
"redirect"
"hostname"
"asn"
name: string

Body param: An informative name for the list. Use this name in filter and rule expressions.

maxLength50
description?: string

Body param: An informative summary of the list.

maxLength500
ReturnsExpand Collapse
ListCreateResponse { id, created_on, kind, 5 more }
id: string

The unique ID of the list.

maxLength32
minLength32
created_on: string

The RFC 3339 timestamp of when the list was created.

kind: "ip" | "redirect" | "hostname" | "asn"

The type of the list. Each type supports specific list items (IP addresses, ASNs, hostnames or redirects).

One of the following:
"ip"
"redirect"
"hostname"
"asn"
modified_on: string

The RFC 3339 timestamp of when the list was last modified.

name: string

An informative name for the list. Use this name in filter and rule expressions.

maxLength50
num_items: number

The number of items in the list.

num_referencing_filters: number

The number of filters referencing the list.

description?: string

An informative summary of the list.

maxLength500

Create a list

import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted
});

const list = await client.rules.lists.create({
  account_id: '023e105f4ecef8ad9ca31a8372d0c353',
  kind: 'ip',
  name: 'list1',
});

console.log(list.id);
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "2c0fc9fa937b11eaa1b71c4d701ab86e",
    "created_on": "2020-01-01T08:00:00Z",
    "kind": "ip",
    "modified_on": "2020-01-10T14:00:00Z",
    "name": "list1",
    "num_items": 10,
    "num_referencing_filters": 2,
    "description": "This is a note"
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "2c0fc9fa937b11eaa1b71c4d701ab86e",
    "created_on": "2020-01-01T08:00:00Z",
    "kind": "ip",
    "modified_on": "2020-01-10T14:00:00Z",
    "name": "list1",
    "num_items": 10,
    "num_referencing_filters": 2,
    "description": "This is a note"
  },
  "success": true
}